Proxmox/setup/nginx-proxy-manager-install.sh

281 lines
7.9 KiB
Bash
Raw Normal View History

2022-04-25 17:15:17 +02:00
#!/usr/bin/env bash
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-03-11 04:24:52 +01:00
RETRY_NUM=10
2022-02-24 05:39:17 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-18 14:00:11 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:15:17 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 17:15:17 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-18 14:00:11 +02:00
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-18 14:00:11 +02:00
}
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-04-18 14:00:11 +02:00
}
2022-08-31 11:20:58 +02:00
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-08-31 11:20:58 +02:00
}
2022-04-18 14:00:11 +02:00
msg_info "Setting up Container OS "
2022-02-24 05:39:17 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-02-24 05:39:17 +01:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-02-24 05:39:17 +01:00
exit 1
fi
done
2022-04-18 14:00:11 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-02-24 05:39:17 +01:00
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-08-31 11:20:58 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-18 14:00:11 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Updated Container OS"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Installing Dependencies"
2022-02-24 05:39:17 +01:00
apt-get update &>/dev/null
2022-06-30 14:54:15 +02:00
apt-get -y install \
2022-10-30 02:04:45 +01:00
sudo \
curl \
gnupg \
make \
g++ \
gcc \
ca-certificates \
apache2-utils \
logrotate \
build-essential \
python3-dev \
git \
lsb-release &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Installed Dependencies"
2022-02-24 05:39:17 +01:00
2022-06-30 14:54:15 +02:00
msg_info "Installing Python"
2022-10-30 02:04:45 +01:00
apt-get install -y -q --no-install-recommends python3 python3-pip python3-venv &>/dev/null
pip3 install --upgrade setuptools &>/dev/null
pip3 install --upgrade pip &>/dev/null
python3 -m venv /opt/certbot/ &>/dev/null
if [ "$(getconf LONG_BIT)" = "32" ]; then
python3 -m pip install --no-cache-dir -U cryptography==3.3.2 &>/dev/null
fi
python3 -m pip install --no-cache-dir cffi certbot &>/dev/null
2022-06-30 14:54:15 +02:00
msg_ok "Installed Python"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Installing Openresty"
2022-02-24 05:39:17 +01:00
wget -q -O - https://openresty.org/package/pubkey.gpg | apt-key add - &>/dev/null
2022-10-30 02:04:45 +01:00
codename=$(grep -Po 'VERSION="[0-9]+ \(\K[^)]+' /etc/os-release) &>/dev/null
2022-02-24 05:39:17 +01:00
echo "deb http://openresty.org/package/debian $codename openresty" | tee /etc/apt/sources.list.d/openresty.list &>/dev/null
apt-get -y update &>/dev/null
apt-get -y install --no-install-recommends openresty &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Installed Openresty"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Setting up Node.js Repository"
2022-06-30 14:54:15 +02:00
curl -fsSL https://deb.nodesource.com/setup_16.x | bash - &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Set up Node.js Repository"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Installing Node.js"
2022-06-30 14:54:15 +02:00
apt-get install -y nodejs &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Installed Node.js"
2022-10-30 02:04:45 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Installing Yarn"
2022-02-24 05:39:17 +01:00
npm install --global yarn &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Installed Yarn"
2022-02-24 05:39:17 +01:00
2022-10-30 02:04:45 +01:00
RELEASE=$(curl -s https://api.github.com/repos/NginxProxyManager/nginx-proxy-manager/releases/latest |
grep "tag_name" |
awk '{print substr($2, 3, length($2)-4) }')
2022-02-28 22:49:04 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Downloading Nginx Proxy Manager v${RELEASE}"
2022-02-28 22:49:04 +01:00
wget -q https://codeload.github.com/NginxProxyManager/nginx-proxy-manager/tar.gz/v${RELEASE} -O - | tar -xz &>/dev/null
cd ./nginx-proxy-manager-${RELEASE}
2022-04-18 14:00:11 +02:00
msg_ok "Downloaded Nginx Proxy Manager v${RELEASE}"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Setting up Enviroment"
2022-02-24 05:39:17 +01:00
ln -sf /usr/bin/python3 /usr/bin/python
ln -sf /usr/bin/certbot /opt/certbot/bin/certbot
ln -sf /usr/local/openresty/nginx/sbin/nginx /usr/sbin/nginx
ln -sf /usr/local/openresty/nginx/ /etc/nginx
2022-02-28 22:49:04 +01:00
sed -i "s+0.0.0+${RELEASE}+g" backend/package.json
sed -i "s+0.0.0+${RELEASE}+g" frontend/package.json
2022-02-24 05:39:17 +01:00
sed -i 's+^daemon+#daemon+g' docker/rootfs/etc/nginx/nginx.conf
NGINX_CONFS=$(find "$(pwd)" -type f -name "*.conf")
for NGINX_CONF in $NGINX_CONFS; do
sed -i 's+include conf.d+include /etc/nginx/conf.d+g' "$NGINX_CONF"
done
mkdir -p /var/www/html /etc/nginx/logs
cp -r docker/rootfs/var/www/html/* /var/www/html/
cp -r docker/rootfs/etc/nginx/* /etc/nginx/
cp docker/rootfs/etc/letsencrypt.ini /etc/letsencrypt.ini
cp docker/rootfs/etc/logrotate.d/nginx-proxy-manager /etc/logrotate.d/nginx-proxy-manager
ln -sf /etc/nginx/nginx.conf /etc/nginx/conf/nginx.conf
rm -f /etc/nginx/conf.d/dev.conf
mkdir -p /tmp/nginx/body \
2022-10-30 02:04:45 +01:00
/run/nginx \
/data/nginx \
/data/custom_ssl \
/data/logs \
/data/access \
/data/nginx/default_host \
/data/nginx/default_www \
/data/nginx/proxy_host \
/data/nginx/redirection_host \
/data/nginx/stream \
/data/nginx/dead_host \
/data/nginx/temp \
/var/lib/nginx/cache/public \
/var/lib/nginx/cache/private \
/var/cache/nginx/proxy_temp
2022-02-24 05:39:17 +01:00
chmod -R 777 /var/cache/nginx
chown root /tmp/nginx
2022-10-30 02:04:45 +01:00
echo resolver "$(awk 'BEGIN{ORS=" "} $1=="nameserver" {print ($2 ~ ":")? "["$2"]": $2}' /etc/resolv.conf);" >/etc/nginx/conf.d/include/resolvers.conf
2022-04-18 14:00:11 +02:00
2022-02-24 05:39:17 +01:00
if [ ! -f /data/nginx/dummycert.pem ] || [ ! -f /data/nginx/dummykey.pem ]; then
echo -en "${GN} Generating dummy SSL Certificate... "
openssl req -new -newkey rsa:2048 -days 3650 -nodes -x509 -subj "/O=Nginx Proxy Manager/OU=Dummy Certificate/CN=localhost" -keyout /data/nginx/dummykey.pem -out /data/nginx/dummycert.pem &>/dev/null
fi
mkdir -p /app/global /app/frontend/images
cp -r backend/* /app
cp -r global/* /app/global
2022-04-18 14:00:11 +02:00
msg_ok "Set up Enviroment"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Building Frontend"
2022-02-24 05:39:17 +01:00
cd ./frontend
export NODE_ENV=development
yarn install --network-timeout=30000 &>/dev/null
yarn build &>/dev/null
cp -r dist/* /app/frontend
cp -r app-images/* /app/frontend/images
2022-04-18 14:00:11 +02:00
msg_ok "Built Frontend"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Initializing Backend"
2022-02-24 05:39:17 +01:00
rm -rf /app/config/default.json &>/dev/null
if [ ! -f /app/config/production.json ]; then
2022-10-30 02:04:45 +01:00
cat <<'EOF' >/app/config/production.json
2022-02-24 05:39:17 +01:00
{
"database": {
"engine": "knex-native",
"knex": {
"client": "sqlite3",
"connection": {
"filename": "/data/database.sqlite"
}
}
}
}
EOF
fi
cd /app
export NODE_ENV=development
yarn install --network-timeout=30000 &>/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Initialized Backend"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Creating Service"
2022-10-30 02:04:45 +01:00
cat <<'EOF' >/lib/systemd/system/npm.service
2022-02-24 05:39:17 +01:00
[Unit]
Description=Nginx Proxy Manager
After=network.target
Wants=openresty.service
[Service]
Type=simple
Environment=NODE_ENV=production
ExecStartPre=-mkdir -p /tmp/nginx/body /data/letsencrypt-acme-challenge
ExecStart=/usr/bin/node index.js --abort_on_uncaught_exception --max_old_space_size=250
WorkingDirectory=/app
Restart=on-failure
[Install]
WantedBy=multi-user.target
EOF
2022-04-18 14:00:11 +02:00
msg_ok "Created Service"
2022-02-24 05:39:17 +01:00
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-02-24 05:39:17 +01:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
if [[ "${SSH_ROOT}" == "yes" ]]; then
cat <<EOF >>/etc/ssh/sshd_config
PermitRootLogin yes
EOF
systemctl restart sshd
fi
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Starting Services"
2022-02-24 05:39:17 +01:00
systemctl enable npm &>/dev/null
systemctl start openresty
systemctl start npm
2022-04-18 14:00:11 +02:00
msg_ok "Started Services"
2022-02-24 05:39:17 +01:00
2022-04-18 14:00:11 +02:00
msg_info "Cleaning up"
2022-02-24 05:39:17 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-04-18 14:00:11 +02:00
msg_ok "Cleaned"